using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Runtime.InteropServices;


namespace Mifare1K
{     

    public partial class ICODE : Form
    {
        [DllImport("kernel32.dll")]
        static extern void Sleep(int dwMilliseconds);

        //=========================== System Function =============================
        [DllImport("hfrdapi.dll")]
        static extern int Sys_GetDeviceNum(UInt16 vid, UInt16 pid, ref UInt32 pNum);

        [DllImport("hfrdapi.dll")]
        static extern int Sys_GetHidSerialNumberStr(UInt32 deviceIndex,
                                                    UInt16 vid,
                                                    UInt16 pid,
                                                    [Out]StringBuilder deviceString,
                                                    UInt32 deviceStringLength);

        [DllImport("hfrdapi.dll")]
        static extern int Sys_Open(ref IntPtr device,
                                   UInt32 index,
                                   UInt16 vid,
                                   UInt16 pid);

        [DllImport("hfrdapi.dll")]
        static extern bool Sys_IsOpen(IntPtr device);

        [DllImport("hfrdapi.dll")]
        static extern int Sys_Close(ref IntPtr device);

        [DllImport("hfrdapi.dll")]
        static extern int Sys_SetLight(IntPtr device, byte color);

        [DllImport("hfrdapi.dll")]
        static extern int Sys_SetBuzzer(IntPtr device, byte msec);

        [DllImport("hfrdapi.dll")]
        static extern int Sys_SetAntenna(IntPtr device, byte mode);

        [DllImport("hfrdapi.dll")]
        static extern int Sys_InitType(IntPtr device, byte type);

        //=========================== Auxiliary Function ===========================
        [DllImport("hfrdapi.dll")]
        static extern int Aux_SingleDES(byte desType,
                                        byte[] key,
                                        byte[] srcData,
                                        UInt32 srcDataLen,
                                        byte[] destData,
                                        ref UInt32 destDataLen);

        [DllImport("hfrdapi.dll")]
        static extern int Aux_TripleDES(byte desType,
                                        byte[] key,
                                        byte[] srcData,
                                        UInt32 srcDataLen,
                                        byte[] destData,
                                        ref UInt32 destDataLen);

        [DllImport("hfrdapi.dll")]
        static extern int Aux_SingleMAC(byte[] key,
                                        byte[] initData,
                                        byte[] srcData,
                                        UInt32 srcDataLen,
                                        byte[] macData);

        [DllImport("hfrdapi.dll")]
        static extern int Aux_TripleMAC(byte[] key,
                                        byte[] initData,
                                        byte[] srcData,
                                        UInt32 srcDataLen,
                                        byte[] macData);

        //=========================== M1 Card Function =============================
        [DllImport("hfrdapi.dll")]
        static extern int TyA_Request(IntPtr device, byte mode, ref UInt16 pTagType);

        [DllImport("hfrdapi.dll")]
        static extern int TyA_Anticollision(IntPtr device,
                                            byte bcnt,
                                            byte[] pSnr,
                                            ref byte pLen);

        [DllImport("hfrdapi.dll")]
        static extern int TyA_Select(IntPtr device,
                                     byte[] pSnr,
                                     byte snrLen,
                                     ref byte pSak);

        [DllImport("hfrdapi.dll")]
        static extern int TyA_Halt(IntPtr device);

        [DllImport("hfrdapi.dll")]
        static extern int TyA_CS_Authentication2(IntPtr device,
                                                 byte mode,
                                                 byte block,
                                                 byte[] pKey);

        [DllImport("hfrdapi.dll")]
        static extern int TyA_CS_Read(IntPtr device,
                                      byte block,
                                      byte[] pData,
                                      ref byte pLen);

        [DllImport("hfrdapi.dll")]
        static extern int TyA_CS_Write(IntPtr device, byte block, byte[] pData);

        [DllImport("hfrdapi.dll")]
        static extern int TyA_CS_InitValue(IntPtr device, byte block, Int32 value);

        [DllImport("hfrdapi.dll")]
        static extern int TyA_CS_ReadValue(IntPtr device, byte block, ref Int32 pValue);

        [DllImport("hfrdapi.dll")]
        static extern int TyA_CS_Decrement(IntPtr device, byte block, Int32 value);

        [DllImport("hfrdapi.dll")]
        static extern int TyA_CS_Increment(IntPtr device, byte block, Int32 value);

        [DllImport("hfrdapi.dll")]
        static extern int TyA_CS_Restore(IntPtr device, byte block);  

        [DllImport("hfrdapi.dll")]
        static extern int TyA_CS_Transfer(IntPtr device, byte block);

        //======================= Ultralight(C) Card Function ====================== 
        [DllImport("hfrdapi.dll")]
        static extern int TyA_UL_Select(IntPtr device, byte[] pSnr, ref byte pLen);

        [DllImport("hfrdapi.dll")]
        static extern int TyA_UL_Write(IntPtr device, byte page, byte[] pdata);

        [DllImport("hfrdapi.dll")]
        static extern int TyA_UL_Authentication(IntPtr device, byte[] pKey);

        [DllImport("hfrdapi.dll")]
        static extern int TyA_UL_ChangeKey(IntPtr device, byte[] pKey);


        //========================= ISO15693 Card Function =========================
        [DllImport("hfrdapi.dll")]
        static extern int I15693_Inventory(IntPtr device, byte[] pData, ref byte pLen);

        [DllImport("hfrdapi.dll")]
        static extern int I15693_Inventorys(IntPtr device, byte[] pData, ref byte pLen);

        [DllImport("hfrdapi.dll")]
        static extern int I15693_GetSystemInformation(IntPtr device,
                                                      byte mode,
                                                      byte[] pUID,
                                                      byte[] pData,
                                                      ref byte pLen);

        [DllImport("hfrdapi.dll")]
        static extern int I15693_Select(IntPtr device, byte[] pUID);

        [DllImport("hfrdapi.dll")]
        static extern int I15693_ResetToReady(IntPtr device, byte mode, byte[] pUID);

        [DllImport("hfrdapi.dll")]
        static extern int I15693_StayQuiet(IntPtr device, byte[] pUID);

        [DllImport("hfrdapi.dll")]
        static extern int I15693_GetBlockSecurity(IntPtr device,
                                                  byte mode,
                                                  byte[] pUID,
                                                  byte block,
                                                  byte number,
                                                  byte[] pData,
                                                  ref byte pLen);

        [DllImport("hfrdapi.dll")]
        static extern int I15693_Read(IntPtr device,
                                      byte mode,
                                      byte[] pUID,
                                      byte block,
                                      byte number,
                                      byte[] pData,
                                      ref byte pLen);

        [DllImport("hfrdapi.dll")]
        static extern int I15693_Write(IntPtr device,
                                       byte mode,
                                       byte[] pUID,
                                       byte block,
                                       byte[] pData);

        [DllImport("hfrdapi.dll")]
        static extern int I15693_LockBlock(IntPtr device,
                                           byte mode,
                                           byte[] pUID,
                                           byte block);

        [DllImport("hfrdapi.dll")]
        static extern int I15693_WriteAFI(IntPtr device, 
                                          byte mode,
                                          byte[] pUID,
                                          byte AFI);

        [DllImport("hfrdapi.dll")]
        static extern int I15693_LockAFI(IntPtr device, byte mode, byte[] pUID);

        [DllImport("hfrdapi.dll")]
        static extern int I15693_WriteDSFID(IntPtr device,
                                            byte mode,
                                            byte[] pUID,
                                            byte DSFID);

        [DllImport("hfrdapi.dll")]
        static extern int I15693_LockDSFID(IntPtr device, byte mode, byte[] pUID);

        [DllImport("hfrdapi.dll")]
        static extern int I15693_DirectTransmit(IntPtr device,
                                                byte[] pCommand,
                                                byte cmdLen,
                                                byte[] pData,
                                                ref byte pMsgLg);


        //======================== ISO14443A-4 Card Function =======================
        [DllImport("hfrdapi.dll")]
        static extern int TyA_Reset(IntPtr device,
                                    byte mode,
                                    byte[] pData,
                                    ref byte pMsgLg);

        [DllImport("hfrdapi.dll")]
        static extern int TyA_CosCommand(IntPtr device,
                                         byte[] pCommand,
                                         byte cmdLen,
                                         byte[] pData,
                                         ref byte pMsgLg);

        [DllImport("hfrdapi.dll")]
        static extern int TyA_Deselect(IntPtr device);

        //==========================================================================
        IntPtr g_hDevice = (IntPtr)(-1); //g_hDevice must init as -1

        static char[] hexDigits = { 
            '0','1','2','3','4','5','6','7',
            '8','9','A','B','C','D','E','F'};

        public static byte GetHexBitsValue(byte ch)
        {
            byte sz= 0;
            if (ch <= '9' && ch >= '0')
                sz = (byte)(ch - 0x30);
            if (ch <= 'F' && ch >= 'A')
                sz = (byte)(ch - 0x37);
            if (ch <= 'f' && ch >= 'a')
                sz = (byte)(ch - 0x57);

            return sz;
        }
        //

        #region byteHEX
        /// <summary>
        /// 单个字节转字字符.
        /// </summary>
        /// <param name="ib">字节.</param>
        /// <returns>转换好的字符.</returns>
        public static String byteHEX(Byte ib)
        {
            String _str = String.Empty;
            try
            {
                char[] Digit = { '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A',
			    'B', 'C', 'D', 'E', 'F' };
                char[] ob = new char[2];
                ob[0] = Digit[(ib >> 4) & 0X0F];
                ob[1] = Digit[ib & 0X0F];
                _str = new String(ob);
            }
            catch (Exception)
            {
                new Exception("byteHEX error !");
            }
            return _str;

        }
        #endregion

        public static string ToHexString(byte[] bytes)
        {
            String hexString=String.Empty;
            for(int i = 0 ;i < bytes.Length;i++)
                hexString += byteHEX(bytes[i]);

            return hexString;
        }

        public static string ToHexString(byte[] bytes, byte len)
        {
            String hexString = String.Empty;
            for (int i = 0; i < len; i++)
                hexString += byteHEX(bytes[i]);

            return hexString;
        }

        public static byte[] ToDigitsBytes(string theHex)
        {
            byte[] bytes = new byte[theHex.Length / 2 + (((theHex.Length % 2) > 0)?1:0)];
            for (int i = 0; i < bytes.Length;i++ )
            {
                char lowbits = theHex[i * 2];
                char highbits;

                if ((i * 2 + 1) < theHex.Length)
                    highbits = theHex[i * 2 + 1];
                else
                    highbits = '0';

                int a = (int)GetHexBitsValue((byte)lowbits);
                int b = (int)GetHexBitsValue((byte)highbits);
                bytes[i] = (byte)((a << 4) + b);
            }

            return bytes;
        }

        /**/
        public ICODE()
        {
            InitializeComponent();
        }

        private void Mifare_1K_Load(object sender, EventArgs e)
        {
            cbxBlock.SelectedIndex = 0;
            textUID.MaxLength = 16;
            textData.MaxLength = 8;
            textStatus.MaxLength = 2;
        }

        private void tsbtnConnect_Click(object sender, EventArgs e)
        {/*toolbar button[connect] clicked*/

            int status;
            string strError;

            //=========================== Open reader =========================
            //Check whether the reader is opened or not
            if (true == Sys_IsOpen(g_hDevice))
            {
                //If the reader is already opened , close it firstly
                status = Sys_Close(ref g_hDevice);
                if (0 != status)
                {
                    strError = "Sys_Close failed !";
                    MessageBox.Show(strError, "error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
            }

            //Open
            status = Sys_Open(ref g_hDevice, 0, 0x0416, 0x8020);
            if (0 != status)
            {
                strError = "Sys_Open failed !";
                MessageBox.Show(strError, "error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }


            //============= Init the reader before operating the card ============
            //Close antenna of the reader
            status = Sys_SetAntenna(g_hDevice, 0);
            if (0 != status)
            {
                strError = "Sys_SetAntenna failed !";
                MessageBox.Show(strError, "error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            Sleep(5); //Appropriate delay after Sys_SetAntenna operating 

            //Set the reader's working mode
            status = Sys_InitType(g_hDevice, (byte)'1');
            if (0 != status)
            {
                strError = "Sys_InitType failed !";
                MessageBox.Show(strError, "error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            Sleep(5); //Appropriate delay after Sys_InitType operating

            //Open antenna of the reader
            status = Sys_SetAntenna(g_hDevice, 1);
            if (0 != status)
            {
                strError = "Sys_SetAntenna failed !";
                MessageBox.Show(strError, "error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            Sleep(5); //Appropriate delay after Sys_SetAntenna operating


            //============================ Success Tips ==========================
            //Beep 200 ms
            status = Sys_SetBuzzer(g_hDevice, 20);
            if (0 != status)
            {
                strError = "Sys_SetBuzzer failed !";
                MessageBox.Show(strError, "error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
        }

        private void btnInventory_Click(object sender, EventArgs e)
        {
            int status;
            byte[] dataBuffer = new byte[64];
            byte len = 0;

            //====== Check whether the reader is opened or not =======
            if (true != Sys_IsOpen(g_hDevice))
            {
                MessageBox.Show("The device has not been opened yet !", "error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            //====================== Read UID ========================
            status = I15693_Inventory(g_hDevice, dataBuffer, ref len);
            //dataBuffer[]: 1 byte DSFID + 8 bytes UID
            if (status != 0)
            {
                MessageBox.Show("I15693_Inventory failed !", "error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            byte[] bytesData = new byte[64];
            for (int i = 0; i < 8; i++)
                bytesData[i] = Marshal.ReadByte(dataBuffer, i+1);
            textUID.Text = ToHexString(bytesData, 8);
        }

        private void btnRead_Click(object sender, EventArgs e)
        {
            int status;
            byte[] dataBuffer = new byte[64];
            byte len = 0;
            byte block;

            //====== Check whether the reader is opened or not ========
            if (true != Sys_IsOpen(g_hDevice))
            {
                MessageBox.Show("The device has not been opened yet !", "error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            //=================== Read block data =====================
            byte[] bytesUID = ToDigitsBytes(textUID.Text);
            block = Convert.ToByte(cbxBlock.Text);

            status = I15693_Read(g_hDevice, 0x02, bytesUID, block, 1, dataBuffer, ref len);
            if (status != 0)
            {
                MessageBox.Show("I15693_Read failed !", "error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            byte[] bytesData = new byte[64];
            for (int i = 0; i < len; i++)
                bytesData[i] = Marshal.ReadByte(dataBuffer, i);
            textData.Text = ToHexString(bytesData, len);

            //=================== Read block security ===================
            status = I15693_GetBlockSecurity(g_hDevice, 0x02, bytesUID, block, 1, dataBuffer, ref len);
            if (status != 0)
            {
                MessageBox.Show("I15693_GetBlockSecurity failed !", "error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            bytesData = new byte[64];
            for (int i = 0; i < len; i++)
                bytesData[i] = Marshal.ReadByte(dataBuffer, i);
            textStatus.Text = ToHexString(bytesData, len);

        }

        private void btnWrite_Click(object sender, EventArgs e)
        {
            int status;
            byte[] dataBuffer = new byte[64];
            byte block;

            //======= Check whether the reader is opened or not ========
            if (true != Sys_IsOpen(g_hDevice))
            {
                MessageBox.Show("The device has not been opened yet !", "error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            //=================== Write block data =====================
            byte[] bytesUID = ToDigitsBytes(textUID.Text);
            block = Convert.ToByte(cbxBlock.Text);
            dataBuffer = ToDigitsBytes(textData.Text);

            status = I15693_Write(g_hDevice, 0x02, bytesUID, block, dataBuffer);
            if (status != 0)
            {
                MessageBox.Show("I15693_Write failed !", "error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
        }

        private void btnLock_Click(object sender, EventArgs e)
        {
            int status;
            byte[] dataBuffer = new byte[64];
            byte block;

            //====== Check whether the reader is opened or not =======
            if (true != Sys_IsOpen(g_hDevice))
            {
                MessageBox.Show("The device has not been opened yet !", "error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            //===================== Lock block =======================
            byte[] bytesUID = ToDigitsBytes(textUID.Text);
            block = Convert.ToByte(cbxBlock.Text);

            if (DialogResult.Cancel == MessageBox.Show("Are you sure to lock the block? After locking, the block contents cannot be changed anymore.", 
                                                       "Warning", MessageBoxButtons.OKCancel, MessageBoxIcon.Warning))
                return;

            status = I15693_LockBlock(g_hDevice, 0x02, bytesUID, block);
            if (status != 0)
            {
                MessageBox.Show("I15693_LockBlock failed !", "error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
        }

    }
}
